using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;

using ArtOfTest.Common.UnitTesting;
using ArtOfTest.WebAii.Core;
using ArtOfTest.WebAii.Controls.HtmlControls;
using ArtOfTest.WebAii.Controls.HtmlControls.HtmlAsserts;
using ArtOfTest.WebAii.Design;
using ArtOfTest.WebAii.Design.Execution;
using ArtOfTest.WebAii.ObjectModel;
using ArtOfTest.WebAii.Silverlight;
using ArtOfTest.WebAii.Silverlight.UI;
using ArtOfTest.WebAii.Wpf;
using Telerik.WebAii.Controls.Xaml.Wpf;
using ArtOfTest.WebAii.Win32.Dialogs;

namespace TestExamplesProject
{
    public class HandleSaveFileDialog : BaseWebAiiTest
    {
        #region [ Dynamic Applications Reference ]

        private Applications _applications;

        /// <summary>
        /// Gets the Applications object that has references
        /// to all the elements, windows or regions
        /// in this project.
        /// </summary>
        public Applications Applications
        {
            get
            {
                if (_applications == null)
                {
                    _applications = new Applications(Manager.Current);
                }
                return _applications;
            }
        }

        #endregion

        SaveAsDialog saveDialog;

        [CodedStep(@"LeftClick on OpenCustomTextblock")]
        public void HandleSaveAsDialog_CodedStep()
        {
            saveDialog = SaveAsDialog.CreateSaveAsDialog(ActiveApplication, DialogButton.SAVE, "F:\\FileToSave.txt");
            //OpenFileDialog saveDialog = OpenFileDialog.CreateOpenFileDialog(ActiveApplication, DialogButton.OPEN, "F:\\FileToSave.txt");
            //saveDialog.HandlerDelegate = MySaveHandlerDelegate;
            Manager.DialogMonitor.AddDialog(saveDialog);
            Manager.DialogMonitor.Start();

            // LeftClick on OpenDefaultTextblock
            Applications.WpfApplication1exe.MainWindow0.OpenDefaultTextblock.User.Click(ArtOfTest.WebAii.Core.MouseClickType.LeftClick, 49, 44, ArtOfTest.Common.OffsetReference.TopLeftCorner, ArtOfTest.Common.ActionPointUnitType.Percentage, ((System.Windows.Forms.Keys)(0)));

            // LeftClick on OpenCustomTextblock
            //Applications.WpfApplication1exe.MainWindow0.OpenCustomTextblock.User.Click();

            saveDialog.WaitUntilHandled(10000);
        }

        public void MySaveHandlerDelegate(IDialog dialog)
        {
            // Set focus to the input edit field
            dialog.Window.AllChildren[0].AllChildren[0].AllChildren[0].AllChildren[0].AllChildren[0].SetFocus();

            // Enter the filename to save to
            //Manager.Desktop.KeyBoard.TypeText(saveDialog.SaveFileName);
            Manager.Desktop.KeyBoard.TypeText("F:\\savefile.txt");

            // Type Alt/S to save file and close dialog
            dialog.Window.SetFocus();
            Manager.Desktop.KeyBoard.KeyDown(System.Windows.Forms.Keys.Alt);
            Manager.Desktop.KeyBoard.KeyPress(System.Windows.Forms.Keys.S);
            Manager.Desktop.KeyBoard.KeyUp(System.Windows.Forms.Keys.Alt);

            //well this is one option, the second is: ActiveBrowser.Manager.Desktop.KeyBoard.KeyPress(ArtOfTest.WebAii.Win32.KeyBoard.KeysFromString("Alt+C"), 150, 1); and the third is Manager.Desktop.KeyBoard.SendString("%{S}");
        }
    }
}
